﻿Option Explicit On
Option Strict On

Imports MvpsOrg.Dotnet.Win32.NativeMethods

Namespace MvpsOrg.Dotnet.Win32.Transactions.IO

    ' Values marked with * are defined in 'System.IO.FileOptions'.
    <Flags()> _
    Public Enum FileOptions
        None = FlagsAndAttributes_Flags.None                                    ' *
        [ReadOnly] = FlagsAndAttributes_Flags.FILE_ATTRIBUTE_READONLY
        Hidden = FlagsAndAttributes_Flags.FILE_ATTRIBUTE_HIDDEN
        System = FlagsAndAttributes_Flags.FILE_ATTRIBUTE_SYSTEM
        Directory = FlagsAndAttributes_Flags.FILE_ATTRIBUTE_DIRECTORY
        Archive = FlagsAndAttributes_Flags.FILE_ATTRIBUTE_ARCHIVE
        Device = FlagsAndAttributes_Flags.FILE_ATTRIBUTE_DEVICE
        Normal = FlagsAndAttributes_Flags.FILE_ATTRIBUTE_NORMAL
        Temporary = FlagsAndAttributes_Flags.FILE_ATTRIBUTE_TEMPORARY
        SparseFile = FlagsAndAttributes_Flags.FILE_ATTRIBUTE_SPARSE_FILE
        ReparsePoint = FlagsAndAttributes_Flags.FILE_ATTRIBUTE_REPARSE_POINT
        Compressed = FlagsAndAttributes_Flags.FILE_ATTRIBUTE_COMPRESSED
        Offline = FlagsAndAttributes_Flags.FILE_ATTRIBUTE_OFFLINE
        NotContentIndexed = FlagsAndAttributes_Flags.FILE_ATTRIBUTE_NOT_CONTENT_INDEXED
        Encrypted = FlagsAndAttributes_Flags.FILE_ATTRIBUTE_ENCRYPTED           ' *
        Virtual = FlagsAndAttributes_Flags.FILE_ATTRIBUTE_VIRTUAL
        WriteThrough = FlagsAndAttributes_Flags.FILE_FLAG_WRITE_THROUGH         ' *
        Asynchronous = FlagsAndAttributes_Flags.FILE_FLAG_OVERLAPPED            ' *
        NoBuffering = FlagsAndAttributes_Flags.FILE_FLAG_NO_BUFFERING
        RandomAccess = FlagsAndAttributes_Flags.FILE_FLAG_RANDOM_ACCESS         ' *
        SequentialScan = FlagsAndAttributes_Flags.FILE_FLAG_SEQUENTIAL_SCAN     ' *
        DeleteOnClose = FlagsAndAttributes_Flags.FILE_FLAG_DELETE_ON_CLOSE      ' *
        BackupSemantics = FlagsAndAttributes_Flags.FILE_FLAG_BACKUP_SEMANTICS
        PosixSemantics = FlagsAndAttributes_Flags.FILE_FLAG_POSIX_SEMANTICS
        OpenReparsePoint = FlagsAndAttributes_Flags.FILE_FLAG_OPEN_REPARSE_POINT
        OpenNoRecall = FlagsAndAttributes_Flags.FILE_FLAG_OPEN_NO_RECALL
        SecurityAnonymous = FlagsAndAttributes_Flags.SECURITY_ANONYMOUS
        SecurityIdentification = FlagsAndAttributes_Flags.SECURITY_IDENTIFICATION
        SecurityImpersonation = FlagsAndAttributes_Flags.SECURITY_IMPERSONATION
        SecurityDelegation = FlagsAndAttributes_Flags.SECURITY_DELEGATION
        SecurityContextTracking = FlagsAndAttributes_Flags.SECURITY_CONTEXT_TRACKING
        SecurityEffectiveOnly = FlagsAndAttributes_Flags.SECURITY_EFFECTIVE_ONLY
    End Enum
End Namespace