﻿Option Explicit On
Option Strict On

Imports System.Runtime.InteropServices
Imports System.Security.Permissions

Imports Microsoft.Win32.SafeHandles
Imports MvpsOrg.Dotnet.Win32.NativeMethods


Namespace MvpsOrg.Dotnet.Win32.SafeHandles
    <SecurityPermission(SecurityAction.LinkDemand, UnmanagedCode:=True)> _
    Public NotInheritable Class SafeFindHandle
        Inherits SafeHandleZeroOrMinusOneIsInvalid

        ' Required by the p/invoke marshaller.
        Public Sub New()
            MyBase.New(True)
        End Sub

        Public Sub New( _
            ByVal preexistingHandle As IntPtr, _
            ByVal ownsHandle As Boolean _
        )
            MyBase.New(ownsHandle)
            Me.SetHandle(preexistingHandle)
        End Sub

        Protected Overrides Function ReleaseHandle() As Boolean
            Return FindClose(Me.handle)
        End Function
    End Class
End Namespace