﻿Option Explicit On
Option Strict On

Imports System.Diagnostics.CodeAnalysis
Imports System.Runtime.InteropServices

Namespace MvpsOrg.Dotnet.Win32
    Friend NotInheritable Class WordConverter
        <StructLayout(LayoutKind.Explicit)> _
        Private Structure DWord
            <FieldOffset(0)> Public LongValue As Integer
            <FieldOffset(0)> Public LoWord As Short
            <FieldOffset(2)> Public HiWord As Short
        End Structure

        Private Shared m_DWord As DWord

        Private Sub New()
            '
        End Sub

        Public Shared Function MakeLong( _
            ByVal LoWord As Short, _
            ByVal HiWord As Short _
        ) As Integer
            m_DWord.LoWord = LoWord
            m_DWord.HiWord = HiWord
            Return m_DWord.LongValue
        End Function

        Public Shared Function MakeLong( _
            ByVal LoWord As Integer, _
            ByVal HiWord As Integer _
        ) As Integer
            Return MakeLong(CShort(LoWord), CShort(HiWord))
        End Function

        <SuppressMessage("Microsoft.Performance", "CA1811:AvoidUncalledPrivateCode")> _
        Public Shared Function LoWord(ByVal LongValue As Integer) As Short
            m_DWord.LongValue = LongValue
            Return m_DWord.LoWord
        End Function

        <SuppressMessage("Microsoft.Performance", "CA1811:AvoidUncalledPrivateCode")> _
        Public Shared Function HiWord(ByVal LongValue As Integer) As Short
            m_DWord.LongValue = LongValue
            Return m_DWord.HiWord
        End Function
    End Class
End Namespace