﻿Option Explicit On
Option Strict On

Imports MvpsOrg.Dotnet.Win32.Transactions.Ktm
Imports MvpsOrg.Dotnet.Win32.Transactions.IO

Friend Module Program
    Public Sub Main()
        Dim FileName As String = IO.Path.Combine(IO.Path.GetTempPath(), "test.txt")
        Console.WriteLine("Setting up transaction scope.")
        Using tx As New TransactionScope()
            Console.WriteLine("Creating file ""{0}"".", FileName)
            Dim TestFileStream As IO.FileStream = _
                File.CreateTransactedKtm(FileName)
            Using Writer As New IO.StreamWriter(TestFileStream)
                Console.WriteLine("Writing ""Hello World"" to the file.")
                Writer.Write("Hello World")
            End Using
            Console.WriteLine("Opening the file for reading.")
            Using Reader As New IO.StreamReader(File.OpenTransactedKtm(FileName))
                Console.WriteLine("Reading the first line from the file.")
                Console.WriteLine(Reader.ReadLine())
            End Using
            Console.WriteLine("Determining if the file exists inside the transaction.")
            Console.WriteLine(Directory.GetFilesTransactedKtm(FileName)(0))
            Console.WriteLine("Exiting transaction scope without committing.")
        End Using
        Console.WriteLine("Determining if the file exists outside the transaction.")
        Console.Write(IO.File.Exists(FileName))
#If DEBUG Then
         Console.Read()
#End If
    End Sub
End Module